#ifndef POINTS_H
#define POINTS_H
#include <vector>

using namespace std;

struct Vertex { //вершина
    int x, y; //координаты вершины
    //конструктор по умолчанию
    Vertex ( int a = 0, int b = 0 ) : x(a), y(b) {}
};

//положение точки(внутри, снаружи, на границе)
typedef enum { in, out, border } point_position;

//векторное произведение
double cross_prod ( Vertex, Vertex, Vertex );
//скалярное произведение
double scalar_prod ( Vertex, Vertex, Vertex );
//лежит ли точка на ребре
bool is_point_on_edge ( Vertex, Vertex, Vertex );
//пересекается ли ребро с лучом
bool is_edge_cross ( Vertex, Vertex, Vertex, Vertex );
//выбор точки на луче
Vertex point_on_ray ( Vertex, int );
//расположение точки относительно многоугольника(внутри/снаружи/на границе)
point_position is_point_in_polygon ( vector <Vertex>, Vertex, int );

#endif /* POINTS_H*/
